Attribute VB_Name = "mWinProc"
Option Explicit

Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, _
                         ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, _
                        ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Public Const GWL_WNDPROC = (-4)
Public Const WM_DEVICECHANGE = &H219

Public oldWndProc As Long, watcherPtr As Long
Private m_Hwnd As Long
 
Public Sub SubClass(f As Form)
   If oldWndProc Then UnSubClass
   m_Hwnd = f.hWnd
   oldWndProc = SetWindowLong(m_Hwnd, GWL_WNDPROC, AddressOf WndProc)
End Sub
 
Public Sub UnSubClass()
   If m_Hwnd = 0 Then Exit Sub
   If oldWndProc = 0 Then Exit Sub
   SetWindowLong m_Hwnd, GWL_WNDPROC, oldWndProc
   oldWndProc = 0: m_Hwnd = 0
End Sub

Public Function WndProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Dim hdr As DEV_BROADCAST_HDR
    Dim DBI As DEV_BROADCAST_DEVICEINTERFACE2
    Dim DBV As DEV_BROADCAST_VOLUME
    Dim s As String, sGUID As String
    If Msg = WM_DEVICECHANGE Then
       If wParam <> DBT_DEVICEARRIVAL Then
          If wParam <> DBT_DEVICEREMOVECOMPLETE Then
             ResolvePointer(watcherPtr).FireEvent wParam
          End If
       End If
       Select Case wParam
              Case DBT_CONFIGCHANGED
              Case DBT_CONFIGCHANGECANCELED
              Case DBT_CUSTOMEVENT
              Case DBT_DEVICEARRIVAL
                   CopyMemory hdr, ByVal (lParam), Len(hdr)
                   If hdr.devType <> DBT_DEVTYP_DEVICEINTERFACE Then
                      If hdr.devType <> DBT_DEVTYP_VOLUME Then
                         ResolvePointer(watcherPtr).FireEvent wParam, hdr.devType
                      End If
                   End If
                   Select Case hdr.devType
                          Case DBT_DEVTYP_OEM
                          Case DBT_DEVTYP_DEVNODE
                          Case DBT_DEVTYP_VOLUME
                                CopyMemory DBV, ByVal (lParam), ByVal (hdr.cbSize)
                                If (DBV.flags And DBTF_MEDIA) Then
                                   s = "New media in drive added: "
                                ElseIf DBV.flags And DBTF_NET Then
                                   s = "New network drive added: "
                                Else
                                   s = "New logical drive added: "
                                End If
                                s = s & VolumeFromMask(DBV.UnitMask) & ":\"
                                ResolvePointer(watcherPtr).FireEvent wParam, hdr.devType, , s
                          Case DBT_DEVTYP_PORT
                          Case DBT_DEVTYP_NET
                          Case DBT_DEVTYP_DEVICEINTERFACE
                                CopyMemory DBI, ByVal (lParam), ByVal (hdr.cbSize)
                                sGUID = StringFromGUID(DBI.ClassGuid)
                                ResolvePointer(watcherPtr).FireEvent wParam, hdr.devType, sGUID, TrimNull(DBI.Name)
                          Case DBT_DEVTYP_HANDLE
                          Case Else
                   End Select
              Case DBT_DEVICEQUERYREMOVE
              Case DBT_DEVICEQUERYREMOVEFAILED
              Case DBT_DEVICEREMOVECOMPLETE
                   CopyMemory hdr, ByVal (lParam), Len(hdr)
                   If hdr.devType <> DBT_DEVTYP_DEVICEINTERFACE Then
                      If hdr.devType <> DBT_DEVTYP_VOLUME Then
                         ResolvePointer(watcherPtr).FireEvent wParam, hdr.devType
                      End If
                   End If
                   Select Case hdr.devType
                          Case DBT_DEVTYP_OEM
                          Case DBT_DEVTYP_DEVNODE
                          Case DBT_DEVTYP_VOLUME
                                CopyMemory DBV, ByVal (lParam), ByVal (hdr.cbSize)
                                If (DBV.flags And DBTF_MEDIA) Then
                                   s = "Media from drive "
                                ElseIf DBV.flags And DBTF_NET Then
                                   s = "Network drive "
                                Else
                                   s = "Logical drive "
                                End If
                                s = s & VolumeFromMask(DBV.UnitMask) & ":\ removed"
                                ResolvePointer(watcherPtr).FireEvent wParam, hdr.devType, , s
                          Case DBT_DEVTYP_PORT
                          Case DBT_DEVTYP_NET
                          Case DBT_DEVTYP_DEVICEINTERFACE
                                CopyMemory DBI, ByVal (lParam), ByVal (hdr.cbSize)
                                sGUID = StringFromGUID(DBI.ClassGuid)
                                ResolvePointer(watcherPtr).FireEvent wParam, hdr.devType, sGUID, TrimNull(DBI.Name)
                          Case DBT_DEVTYP_HANDLE
                          Case Else
                   End Select
              Case DBT_DEVICEREMOVEPENDING
              Case DBT_DEVICETYPESPECIFIC
              Case DBT_DEVNODES_CHANGED
              Case DBT_QUERYCHANGECONFIG
              Case DBT_USERDEFINED
              Case Else
       End Select
    End If
    WndProc = CallWindowProc(oldWndProc, hWnd, Msg, wParam, lParam)
End Function

Private Function ResolvePointer(ByVal lpObj&) As cUSBWatcher
   Dim oWatcher As cUSBWatcher
   CopyMemory oWatcher, lpObj, 4
   Set ResolvePointer = oWatcher
   CopyMemory oWatcher, 0&, 4
End Function

Public Function TrimNull(startstr As String) As String
   Dim pos As Integer
   pos = InStr(startstr, Chr$(0))
   If pos Then
      TrimNull = Left$(startstr, pos - 1)
      Exit Function
   End If
   TrimNull = startstr
End Function


